//<#!@READ-ONLY-SECTION-START@!#>
/*
 * \class cfm_producer_1
 * \brief Intel(R) CoFluent(TM) Studio - Intel Corporation
 * \details Simulation model of VulcanoApp generated by C++ Generator for SystemC/TLM2
 */
#include "cfm_producer_1.h"
using namespace std;
using namespace sc_core;
using namespace cf_dt;
using namespace cf_pk;
using namespace cf_core;

//<#!@READ-ONLY-SECTION-END@!#>
//Start of 'Producer_1 definitions' algorithm generated code

//End of 'Producer_1 definitions' algorithm generated code
//<#!@READ-ONLY-SECTION-START@!#>

/// \name constructor
//@{
cfm_producer_1::cfm_producer_1(sc_core::sc_module_name name) :
		cf_function(name), p_mq_changedQ("p_mq_changedQ"), init("init"), produce(
				"produce") {
	cf_function::init();

	// operations initialization
	CF_OPERATION(init, cfm_op_init);
	init.init();
	CF_OPERATION(produce, cfm_op_produce);
	produce.init();

	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'Producer_1 constructor' algorithm generated code

	//End of 'Producer_1 constructor' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>

	SC_THREAD (cfm_behavior);

	cf_function::elab_end();
}
//@}

/// \name destructor
//@{
cfm_producer_1::~cfm_producer_1(void) {
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'Producer_1 destructor' algorithm generated code

	//End of 'Producer_1 destructor' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>
}
//@}

/// \name pre-elaboration section
//@{
void cfm_producer_1::cb_before_elaboration(void) {
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'Producer_1 pre elaboration' algorithm generated code

	//End of 'Producer_1 pre elaboration' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>
}
//@}

/// \name initialize attributes
//@{
void cfm_producer_1::cb_init_attributes() {

// initialize function attributes
	cfa_do_not_start.init(false);
// cfa_affinity.init();
	cfa_priority.init((cf_count) 0);

	cfa_policy.init(CF_SCHEDULER_POLICY_FF);
	cfa_time_slice.init(cf_expr_duration(10, CF_MS));
	cfa_static_code_size.init(cf_data_size(0, CF_KBYTE));
	cfa_static_data_size.init(cf_data_size(0, CF_KBYTE));
	cfa_static_power.init(cf_power(0, CF_UW));
	cfa_dynamic_power.init(cf_power(0, CF_UW));
	cfa_cost.init(cf_cost(0, CF_USD));
	cfa_dynamic_load.init(cf_resource_load(100, CF_PERCENT));

// initialize operation attributes
	init.cfa_type.init(CF_OP_TYPE_ACTIVE);
	init.cfa_execution_time.init(cf_expr_duration(10, CF_NS));
	init.cfa_dynamic_data_size.init(cf_data_size(0, CF_KBYTE));
	produce.cfa_type.init(CF_OP_TYPE_ACTIVE);
	produce.cfa_execution_time.init(cf_expr_duration(10, CF_NS));
	produce.cfa_dynamic_data_size.init(cf_data_size(0, CF_KBYTE));
	return;
}
//@}

/// \name initialize definitions
//@{
void cfm_producer_1::cb_init_local_vars(void) {
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'Producer_1 initializations' algorithm generated code

	//End of 'Producer_1 initializations' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>
}
//@}

/// \name behavioral model of the Producer_1 function
//@{
void cfm_producer_1::cfm_behavior() {

	behavior_initialize();

	// transaction initialization
	changedQ_trans.set_data_ptr(&changedQ);

	// run init
	run_operation (init);

	while (1) {

		// run produce
		run_operation (produce);
		// output action OutAction
		p_mq_changedQ.send(&changedQ_trans);

	}

	behavior_finalize();
}
//@}
/// \name operation algorithm for init
//@{
void cfm_producer_1::cfm_op_init() {
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'init operation' algorithm generated code

	//End of 'init operation' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>
	return;
}
//@}
/// \name operation algorithm for produce
//@{
void cfm_producer_1::cfm_op_produce() {
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'produce operation' algorithm generated code

	//End of 'produce operation' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>
	return;
}
//@}


//<#!@READ-ONLY-SECTION-END@!#>